#include "CallListSerializer.h"

void CallListSerializer::Serialize(pCallStruct pTmpCallStruct, PBYTE &pBuf)
{
	BYTE *pPtr = pBuf;

	CopyMemory(pPtr, pTmpCallStruct, CALLLIST_HEADER_LEN);
	pPtr += CALLLIST_HEADER_LEN;

	if(pTmpCallStruct->uNameSize > 0){
		UINT serlen = _SerializeString(pPtr, pTmpCallStruct->pszName, CALLLIST_STRING_NAME);	
		pPtr += serlen;
	}
	if(pTmpCallStruct->uNameTypeSize > 0){
		UINT serlen = _SerializeString(pPtr, pTmpCallStruct->pszNameType, CALLLIST_STRING_NAMETYPE);	
		pPtr += serlen;
	}
	if(pTmpCallStruct->uNoteSize > 0){
		UINT serlen = _SerializeString(pPtr, pTmpCallStruct->pszNote, CALLLIST_STRING_NOTE);	
		pPtr += serlen;
	}
	if(pTmpCallStruct->uNumberSize > 0){
		UINT serlen = _SerializeString(pPtr, pTmpCallStruct->pszNumber, CALLLIST_STRING_NUMBER);	
		pPtr += serlen;
	}
}

DWORD CallListSerializer::_SerializeString(LPBYTE lpDest, LPTSTR lpString, int entryType)
{
	ASSERT(lpDest);
	DWORD dwStringLength = 0;

	if (lpString == NULL)
		return 0;

	dwStringLength = wcslen(lpString) * sizeof(WCHAR);
	if (dwStringLength == 0)
		return 0;

	// copy prefix and string *** WITHOUT NULL TERMINATOR ***
	DWORD prefix = _Prefix(dwStringLength, entryType);
	CopyMemory(lpDest, &prefix, sizeof(prefix));
	CopyMemory((lpDest + sizeof(prefix)), lpString, dwStringLength);

	return sizeof(prefix) + dwStringLength;
}

DWORD CallListSerializer::_Prefix(DWORD dwLength, int entryType)
{
	DWORD prefix = dwLength;
	prefix &= CALLLIST_TYPE_MASK;    // clear type bits
	prefix |= (DWORD)entryType; 

	return prefix;
}