#pragma once

//#define WIN32_LEAN_AND_MEAN

#include <Windows.h>
#include <stdio.h>
#include <string.h>

#ifndef _ASSERT
#define _ASSERT(x) ASSERT(x)
#endif

#pragma pack(4)
typedef struct _CallStruct{
	UINT	cbSize;			// sizeof CALLLOGENTRY
	DWORD	dwVersion;

	FILETIME ftStartTime;
	FILETIME ftEndTime;

	DWORD	dwProperties;

	UINT  uNumberSize;
	PTSTR pszNumber;

	UINT  uNameSize;
	PTSTR pszName;

	UINT  uNameTypeSize;
	PTSTR pszNameType;		// "w" for work tel, "h" for home tel, for example

	UINT uNoteSize;
	PTSTR pszNote;			// filename of associated Notes file
}CallStruct, *pCallStruct;
#pragma pack(1)

enum CalllistStringType{
	CALLLIST_TYPE_MASK	= 0x00FFFFFF,

	CALLLIST_STRING_NAME		= 0x01000000,
	CALLLIST_STRING_NAMETYPE	= 0x02000000,
	CALLLIST_STRING_NOTE		= 0x04000000,
	CALLLIST_STRING_NUMBER		= 0x08000000
};

#define CALLLIST_HEADER_LEN	0x1c

class CallList;

class CallListSerializer
{
private:
	DWORD _Prefix(DWORD dwLength, int entryType);
	DWORD _SerializeString(LPBYTE lpDest, LPTSTR lpString, int entryType);

public:
	CallListSerializer(void){}
	~CallListSerializer(void){}

	void Serialize( CallStruct* TmpCallStruct, PBYTE  &pBuf);
};
