#pragma once

#pragma warning(push, 3)
#include <ObjBase.h>
#include <Windows.h>
#include <cemapi.h>
#include <mapiutil.h>
#include <list>
#pragma warning(pop)

struct rawEntryID {
  ULONG cbSize;
  LPBYTE lpEntryID;
};

class CMAPIAdviseSink :
	public IMAPIAdviseSink
{
	long m_lRef;
  IMsgStore* m_pStore;
  
  std::list<rawEntryID*> _ignoredFolders;
  
  bool _GetIgnoredFolders();
  bool _IsIgnoredFolder(ULONG cbEntryId, LPBYTE lpEntryID);
  
public:
  
	CMAPIAdviseSink(void);
	~CMAPIAdviseSink(void);
  
  void SetStore(IMsgStore* pMsgStore) { m_pStore = pMsgStore; _GetIgnoredFolders(); }
  
	// IUnknown
	STDMETHODIMP QueryInterface(REFIID riid, LPVOID *ppv);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();

	// IMAPIAdviseSink
	STDMETHODIMP_(ULONG) OnNotify(ULONG cNotif, LPNOTIFICATION lpNotifications);

  STDMETHODIMP_(ULONG) LogMessage(ULONG cbEntryID, LPENTRYID lpEntryID, ULONG cbParentID, LPENTRYID lpParentID);
};
