#include "PoomMan.h"
#include "PoomCalendarReader.h"
#include "PoomContactsReader.h"
#include "PoomTaskReader.h"

IPoomFolderReader* CPoomFolderFactor::get(OlDefaultFolders folder, IFolder* pIFolder){
	
	IPoomFolderReader * reader = NULL;

	switch(folder){
		case olFolderCalendar:
			reader = new CPoomCalendarReader(pIFolder);
			break;
		case olFolderContacts:
			reader = new CPoomContactsReader(pIFolder);
			break;
		case olFolderContactsSim:
			break;
		case olFolderTasks:	
			reader = new CPoomTaskReader(pIFolder);
			break;
		case olFolderCities:
			break;
		case olFolderInfrared:
			break;
		default:
			break;
	}

	if(reader)
		reader->SetType(folder);

	return reader;
}