#pragma once

#ifndef __PoomMan_h__
#define __PoomMan_h__

#define olFolderContactsSim 11

#include <windows.h>
//#include <string>
//#include <exception>

#include <cguid.h>
#include <pimstore.h>
//#include <simmgr.h>
#include <map>

#include "Common.h"
#include "PoomSerializer.h"

class CPoomMan;
class CPoomFolderFactor;
class IPoomFolderReader;

class IPoomFolderReader
{
public:
	IPoomFolderReader(IFolder* pIFolder);

	virtual ~IPoomFolderReader();

	virtual INT Count() = 0;
	virtual HRESULT Get(int i, CPoomSerializer *pPoomSerializer, LPBYTE *pBuf, UINT* puBufLen) = 0;
	virtual HRESULT GetOnce(IPOutlookApp* _pIPoomApp, LONG lOid, CPoomSerializer *pPoomSerializer, LPBYTE *pBuf, UINT *puBufLen) = 0;
	
	UINT GetType(){ return _uType; }
	void SetType(UINT uType){ _uType = uType; }

protected:
	virtual IPOutlookItemCollection* getItemCollection();

private:
	UINT _uType;
	IFolder *_pIFolder;
};

class CPoomFolderFactor
{
	public:
		CPoomFolderFactor(void){}
		~CPoomFolderFactor(void){}
		IPoomFolderReader* get(OlDefaultFolders folder, IFolder* pIFolder);
};

//////////////////////////////////////////////////////////////////////////

class CPoomMan
{
	private:
		static CPoomMan* _pInstance;
		static volatile LONG lLock;

		BOOL _bIsValid;
		
		IPOutlookApp* _pIPoomApp;
	
		void _Export();
		void _ExportOnce(DWORD type, LONG lOid);

		IPoomFolderReader* _Export(IPoomFolderReader *reader);
		IPoomFolderReader* _ExportOnce(IPoomFolderReader *reader, LONG lOid);

		HRESULT _SubscribeToNotifications(IPOutlookApp *pPoom, OlDefaultFolders olFolder, UINT uiNotificationsType);
		
	protected:
		CPoomMan();
		static BOOL Initialize();
		IPOutlookApp* GetIPommApp(){ return _pIPoomApp; }

	public:
		~CPoomMan();
		static CPoomMan* self();
		BOOL IsValid(){ return _bIsValid; }
		void Run(UINT uAgentId);	
		void Notifications();
};
#endif